﻿using CYQ.Data;
using CYQ.Data.Cache;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using static CYQ.Data.AppConfig;

namespace CacheManage_Demo
{
    public static class PerformanceTesting
    {
        public static void Start()
        {
            //测试 StackExchange 性能：
            //StackExchange.Start();

            AppConfig.Redis.Servers = "127.0.0.1:6379,127.0.0.1:6380";//,127.0.0.1:6388,127.0.0.1:6381,127.0.0.1:6380 - c123456,127.0.0.1:6381 - c123456,127.0.0.1:6382 - c123456,127.0.0.1:6383 - c123456";
            AppConfig.Redis.ServersBak = "127.0.0.1:6381";
            DistributedCache.Redis.Clear();
            Console.WriteLine("数据已清空。");
            //return;
            //AppConfig.Redis.MaxSocket = 12;
            //AppConfig.Cache.RedisServers = "redis.txt";
            //AppConfig.Cache.RedisServersBak = "redis.bak.txt";

            //DistributedCache.Redis.Set("aaa", Guid.NewGuid().ToString());
            //var obj = DistributedCache.Redis.Get("aaa");
            int readCount = 100000, userDBCount = 1;
            ThreadPool.SetMinThreads(64, 64);
            //ThreadPool.SetMaxThreads(1000, 1000);
            new ThreadRun(128, readCount, userDBCount).Start();

            new ThreadRun(1, readCount, userDBCount).Start();
            new ThreadRun(2, readCount, userDBCount).Start();
            new ThreadRun(4, readCount, userDBCount).Start();
            new ThreadRun(8, readCount, userDBCount).Start();
            new ThreadRun(16, readCount, userDBCount).Start();
            new ThreadRun(32, readCount, userDBCount).Start();
            new ThreadRun(48, readCount, userDBCount).Start();
            for (int j = 0; j < 1; j++)
            {
                new ThreadRun(64, readCount, userDBCount).Start();
            }
            new ThreadRun(78, readCount, userDBCount).Start();
            new ThreadRun(90, readCount, userDBCount).Start();
            new ThreadRun(100, readCount, userDBCount).Start();
            for (int i = 0; i < 1; i++)
            {
                new ThreadRun(128, readCount, userDBCount).Start();
            }
            
            //new ThreadRun(256, readCount, userDBCount).Start();
           // new ThreadRun(100, readCount, userDBCount).Start();
            //new ThreadRun(200, readCount, userDBCount).Start();
            //new ThreadRun(500, readCount, userDBCount).Start();
            //new ThreadRun(1000, readCount, userDBCount).Start();

            //new ThreadRun(500, readCount, userDBCount).Start();
            //new ThreadRun(200, readCount, userDBCount).Start();
            //new ThreadRun(100, readCount, userDBCount).Start();
           // new ThreadRun(48, readCount, userDBCount).Start();
            //new ThreadRun(20, readCount, userDBCount).Start();
            //new ThreadRun(14, readCount, userDBCount).Start();
            //new ThreadRun(6, readCount, userDBCount).Start();
            //new ThreadRun(2, readCount, userDBCount).Start();
            //new ThreadRun(1, readCount, userDBCount).Start();

            Console.WriteLine("End");
            Console.WriteLine(DistributedCache.Redis.WorkInfo);
            //Console.WriteLine(DistributedCache.Redis.CacheInfo.ToJson(false, false));
            Console.Read();
        }
    }
    public class ThreadRun
    {
        int threadCount, setOrReadCount, useDBCount;
        DistributedCache cache;
        public ThreadRun(int threadCount, int setOrReadCount, int useDBCount)
        {
            cache = DistributedCache.Redis;//操作对象
            //cache.Clear();
            this.threadCount = threadCount;
            this.setOrReadCount = setOrReadCount;
            this.useDBCount = useDBCount;
            AppConfig.Redis.UseDBCount = useDBCount;
        }
        System.Diagnostics.Stopwatch gloWatch = new System.Diagnostics.Stopwatch();
        int runEndCount = 0;
        bool isEnd = false;
        public void Start()
        {
            
            gloWatch.Start();
            for (int i = 0; i < threadCount; i++)
            {
                ThreadPool.QueueUserWorkItem(new WaitCallback(ThreadStart), setOrReadCount / threadCount);
            }

            while (!isEnd)
            {
                Thread.Sleep(10);
            }

        }

        public void ThreadStart(object readCount)
        {
            string rndKey = Guid.NewGuid().ToString().Substring(0, 5);
            int max = (int)readCount;
            for (int i = 0; i < max; i++)
            {
                string key = Guid.NewGuid().ToString();// rndKey + "key" + i;
                if (cache.Set(key, key))
                //if (cache.Get("aaa") != null)
                {

                }
                else
                {
                    Console.WriteLine("Set 失败 key :" + key);
                }

            }

            Interlocked.Increment(ref runEndCount);
            if (runEndCount >= threadCount && !isEnd)
            {
                isEnd = true;
                //gloWatch.Stop();
                //Ng  2000ms
                //x     1000ms
                long t = gloWatch.ElapsedMilliseconds;
                Console.WriteLine(string.Format("ThreadCount : {0} , Run : {1}  Time {2} ms ,{3} requests per second. ", threadCount, setOrReadCount, t.ToString(), setOrReadCount * 1000 / t));
                //DistributedCache.Redis.Clear();
                //Console.WriteLine("数据已清空。");
            }
        }
    }
}
